| GlsMap Toolkit 1.10.1

Public Member Functions | Protected Member Functions | List of all members
disti::GlsMapChartDataSource Class Referenceabstract

`#include <gls_map_chart_data_source.h>`

Inheritance diagram for disti::GlsMapChartDataSource:

## Public Member Functions
virtual | ~GlsMapChartDataSource ()
virtual bool | GetAvailableCoverage (GeoRect *dest)=0
virtual unsigned long | GetBestLayer (GlsMapView *view, GlsMapChart *chart) const
virtual void | GetCellList (const GeoRect &coverage, unsigned long layerID, double viewLogicalHeight, double viewGeoHeight, MapChartCellList &viewList)=0
virtual void | PostDraw (GlsMapView *view, GlsMapChart *chart)
virtual bool | AreAllCellsLoaded (GlsMapView *view, GlsMapChart *chart)

## Protected Member Functions
| GlsMapChartDataSource ()

## Detailed Description

/class MapDataSource

Abstract base class to encapsulate map library specific code and data.

Provides a list of MapCells for a given coverage area and layer. A MapDataSource may have just one layer or many layers of MapCells available.

## Member Function Documentation

## ◆ AreAllCellsLoaded()

bool disti::GlsMapChartDataSource::AreAllCellsLoaded | ( | GlsMapView * | view,
|  | GlsMapChart * | chart
| ) |  |
| virtual

Returns if all of the visible cells have finished loading and will be visible on the next frame

Parameters

  view | The GlsMapView used to draw the chart
  chart | The GlsMapChart that is being drawn

Returns
  If all cells are loaded in a view

Reimplemented in disti::DTEDMapChartDataSource.

## ◆ GetAvailableCoverage()

virtual bool disti::GlsMapChartDataSource::GetAvailableCoverage | ( | GeoRect * | dest | ) |
| pure virtual

Sets a GeoRect to describe the area containing all areas covered by this MapDataSource. This area may change as different databases are loaded. Calling this method may be slow. \dest Pointer to a GeoRect to recieve the coverage.

Returns
  true on success (dest contains the coverage description) or false if there was an error (dest is undefined)

Implemented in disti::AifMapChartDataSource, disti::CADRGMapChartDataSource, disti::DNCMapChartDataSource, disti::DTEDMapChartDataSource, disti::GeoTIFFMapChartDataSource, and disti::ShapefileMapChartDataSource.

## ◆ GetBestLayer()

virtual unsigned long disti::GlsMapChartDataSource::GetBestLayer | ( | GlsMapView * | view,
|  | GlsMapChart * | chart
| ) |  | const
| inline virtual

Returns the cell layer ('zoom level') that best matches the given area

Parameters

  view | The GlsMapView used to draw the chart
  chart | The GlsMapChart that is being drawn

Returns
  The recommended layer to use

Note
  Data sources that do not support layers should always return 0.

Reimplemented in disti::CADRGMapChartDataSource, disti::DNCMapChartDataSource, and disti::ShapefileMapChartDataSource.

## ◆ GetCellList()

virtual void disti::GlsMapChartDataSource::GetCellList | ( | const GeoRect & | coverage,
|  | unsigned long | layerID,
|  | double | viewLogicalHeight,
|  | double | viewGeoHeight,
|  | MapChartCellList & | viewList
| ) |  |
| pure virtual

Get the list of the available cells in a given coverage area The caller will AddRef() any of the cells that it will be holding a reference to

Parameters

  coverage | GeoRect describing the requested area
  layerID | Which layer to return MapCells from
  viewLogicalHeight | The height of the view in logical units
  viewGeoHeight | The height of the view in geographic units
  viewList | Pointer MapChartCellList to recieve the list of available cells

Implemented in disti::ShapefileMapChartDataSource, disti::AifMapChartDataSource, disti::CADRGMapChartDataSource, disti::DNCMapChartDataSource, disti::DTEDMapChartDataSource, and disti::GeoTIFFMapChartDataSource.

## ◆ PostDraw()

virtual void disti::GlsMapChartDataSource::PostDraw | ( | GlsMapView * | view,
|  | GlsMapChart * | chart
| ) |  |
| inline virtual

Called after all the cells have been drawn to allow the data source to perform additional rendering if needed

Parameters

  view | The GlsMapView used to draw the chart
  chart | The GlsMapChart that is being drawn

Reimplemented in disti::DNCMapChartDataSource.

The documentation for this class was generated from the following files:

- gls_map_chart_data_source.h
- gls_map_chart_data_source.cpp